-- This Source Code Form is subject to the terms of the Mozilla Public
-- License, v. 2.0. If a copy of the MPL was not distributed with this
-- file, You can obtain one at https://mozilla.org/MPL/2.0/.

{-# LANGUAGE DataKinds, GADTs, AllowAmbiguousTypes, RankNTypes #-}
{-# LANGUAGE FlexibleContexts, FlexibleInstances, ConstraintKinds #-}

module Reflex.GI.Gtk
  ( -- * Running
    runReflexGtk
  , MonadGtk
    -- * Executing IO in GTK context
  , MonadRunGtk
  , runGtk
  , runGtk_
  , runGtkPromise
    -- * Obtaining input from GTK sources
  , module Reflex.GI.Gtk.Input
    -- * Outputting reactive values to GTK widgets
  , module Reflex.GI.Gtk.Output
    -- * Helpers for specific widgets
  , module Reflex.GI.Gtk.Widget.Box
  ) where

import Reflex.GI.Gtk.Class (MonadGtk)
import Reflex.GI.Gtk.Host (runReflexGtk)
import Reflex.GI.Gtk.Input
import Reflex.GI.Gtk.Output
import Reflex.GI.Gtk.Run.Class ( MonadRunGtk
                               , runGtk
                               , runGtk_
                               , runGtkPromise
                               )
import Reflex.GI.Gtk.Widget.Box
